#!perl

# Copyright (C) 2006-2007, The Perl Foundation.
# $Id: /mirror/trunk/languages/APL/t/numbers.t 21234 2007-09-12T19:36:03.214766Z paultcochrane  $

use strict;
use warnings;
use lib qw(APL . lib ../lib ../../lib ../../../lib);
use t::APL tests => 11;

run_apl_is();

__DATA__

=== integer
--- APL: 2
--- out: 2

=== negative integer
--- APL: ⁻2
--- out: ⁻2

=== number
--- APL: 1.44
--- out: 1.44

=== negative number
--- APL: ⁻1.44
--- out: ⁻1.44

=== negative number with no integer component.
--- APL: ⁻0.44
--- out: ⁻0.44

=== integer positive exponent
--- APL: 10E2
--- out: 1000

=== integer negative exponent
--- APL: 10000E⁻2
--- out: 100

=== integer negative exponent (convert to float)
--- APL: 144E⁻2
--- out: 1.44

=== number positive exponent
--- APL: 1.4444E2
--- out: 144.44

=== number negative exponent
--- APL: 1.44E⁻2
--- out: 0.0144

=== number positive exponent (convert to int)
--- APL: 1.4444E4
--- out: 14444
